/*
    FEARLUS model0-7-1: BatchSwarm.h
    Copyright (C) 1999-2003, 2006  Macaulay Institute

    This file is part of FEARLUS model0-7-1, an agent-based model of land use
    change.

    FEARLUS model0-7-1 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7-1 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Interface for the BatchSwarm class -- a swarm for running the model in the
background. There are no displays. The only output is any history, debugging,
or report output specified by the user on the command line.

*/

#import <collections.h>
#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <analysis.h>
#import <activity.h>
#import <sys/types.h>
#import <sys/stat.h>
#import <errno.h>
#import <string.h>
#import <objc/objc-api.h>	// sel_get_name

@class ModelSwarm, Parameter, Reporter;

@interface BatchSwarm: Swarm {
  Parameter *parameter;
  Reporter *reporter;
  unsigned writeHistoryFrequency;
  unsigned seed;

  BOOL dumpHistory;
  BOOL saveDumpedHistory;

  id initialSchedule;
  id historySchedule;
  id reporterSchedule;

  ModelSwarm *modelSwarm;

  char *historyFileName;

}

+create: (id)z;
-buildReporter;
-buildObjects;
-buildActions;
-activateIn: (id)swarmContext;
-go;
-stop;
-(void)setSpecifiedSeed: (unsigned)value;
-writeHistory;
-(void)writeHistoryToFile: (const char *)fileName;
-(void)drop;

@end
